.model small, c
.386
.stack
.data
.code
.startup

    ; Put data handlers need to access in code segment.
    jmp   @F
    prevIRQ0Handler dd 0
    prevIRQ1Handler dd 0
    counter         dw 0
  @@:
  
    ; Hook interrupt 8.
    mov   ax,3508h
    int   21h
    mov   word ptr prevIRQ0Handler,bx
    mov   word ptr prevIRQ0Handler[2],es
    push  ds
    mov   ax,2508h
    push  cs
    pop   ds
    mov   dx,offset IRQ0Handler
    int   21h
    pop   ds
  
    ; Hook interrupt 9.
    mov   ax,3509h
    int   21h
    mov   word ptr prevIRQ1Handler,bx
    mov   word ptr prevIRQ1Handler[2],es
    push  ds
    mov   ax,2509h
    push  cs
    pop   ds
    mov   dx,offset IRQ1Handler
    int   21h
    pop   ds
  
    ; Wait for user to press Escape.
  @@:
    mov   ah,0
    int   16h
    cmp   al,27
    jne   @B

    ; Unhook and exit.    
    push  ds
    lds   dx,prevIRQ0Handler
    mov   ax,2508h
    int   21h
    pop   ds
    push  ds
    lds   dx,prevIRQ1Handler
    mov   ax,2509h
    int   21h
    pop   ds   

.exit
  
; =========================================================
; This will display once per 18 ticks.
; =========================================================
IRQ0Handler:

    ; Enable interrupts immediately.
    sti
    
    inc   cs:counter

    .IF (cs:counter == 18)

      mov   cs:counter,0
      
      push  ax
      push  bx

      ; Display a '0'.
      mov   bx,0
      mov   ah,0eh
      mov   al,'0'
      int   10h

      pop   bx
      pop   ax

    .ENDIF

    ; Chain to the previous handler.
    jmp   cs:prevIRQ0Handler 

; =========================================================
; This will be called at least once each time a key is
; pressed or released, and more than once for most of
; the extended keys.
; =========================================================
IRQ1Handler:

    ; Enable interrupts immediately.
    sti
    
    push  ax
    push  bx

    ; Display a '1'.
    mov   bx,0
    mov   ah,0eh
    mov   al,'1'
    int   10h

    pop   bx
    pop   ax

    ; Chain to the previous handler.
    jmp   cs:prevIRQ1Handler

end

